mtl-2.2.1: Monad classes, using functional dependencies

Copyright | (c) Andy Gill 2001, (c) Oregon Graduate Institute of Science and Technology, 2001
License | BSD-style (see the file LICENSE)
Maintainer | libraries@haskell.org
Stability | experimental
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Control.Monad.List

Description

The List monad.

Synopsis

- newtype ListT m a :: (* -> *) -> * -> * = ListT {
  - runListT :: m [a]
  }
- mapListT :: (m [a] -> n [b]) -> ListT m a -> ListT n b
- module Control.Monad
- module Control.Monad.Trans

# Documentation

newtype ListT m a :: (* -> *) -> * -> *

Parameterizable list monad, with an inner monad.

Note: this does not yield a monad unless the argument monad is commutative.

Constructors

ListT |

Fields

runListT :: m [a]

Instances

MonadTrans ListT |
MonadState s m => MonadState s (ListT m) Source |
MonadReader r m => MonadReader r (ListT m) Source |
MonadError e m => MonadError e (ListT m) Source |
Monad m => Monad (ListT m) |
Functor m => Functor (ListT m) |
Applicative m => Applicative (ListT m) |
Foldable f => Foldable (ListT f) |
Traversable f => Traversable (ListT f) |
Applicative m => Alternative (ListT m) |
Monad m => MonadPlus (ListT m) |
Eq1 m => Eq1 (ListT m) |
Ord1 m => Ord1 (ListT m) |
Read1 m => Read1 (ListT m) |
Show1 m => Show1 (ListT m) |
MonadIO m => MonadIO (ListT m) |
MonadCont m => MonadCont (ListT m) Source |
(Eq1 m, Eq a) => Eq (ListT m a) |
(Ord1 m, Ord a) => Ord (ListT m a) |
(Read1 m, Read a) => Read (ListT m a) |
(Show1 m, Show a) => Show (ListT m a) |

mapListT :: (m [a] -> n [b]) -> ListT m a -> ListT n b

Map between `ListT` computations.

-     runListT (mapListT f m) = f (runListT m)

module Control.Monad

module Control.Monad.Trans